Unit ash2et_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure ash2et(var A :Array of Extended; var B :Array of Extended;
                 var X :Array of Extended; N :Integer; NC :Integer);

implementation

procedure ash2et(var A :Array of Extended; var B :Array of Extended;
                var X :Array of Extended; N :Integer; NC :Integer);
var
K1,NC1,IW,L,I,K,KL,J,N1 :Integer;
SUM :Extended;
const
ZERO :Extended = 0.0e0;
label
_1,_2,_3,_4,_5,_6,_7,_8;
begin
NC1 := NC+1;
IW := 0;
L := 0;
for I:=1 to N do
 begin
  SUM := B[I-1];
  if ( NC <= 0 ) 
   then goto _3;
  if ( IW = 0 ) 
   then goto _2;
  L := L+1;
  if ( L > NC ) 
   then L := NC;
  K := NC1-L;
  KL := I-L;
  for J:=K to NC do
   begin
    SUM := SUM-X[KL-1]*A[(I-1)+(J-1)*N];
    KL := KL+1;
_1:
   end;
  goto _3;
_2:
  if ( SUM <> ZERO ) 
   then IW := 1;
_3:
  X[I-1] := SUM/A[(I-1)+(NC1-1)*N];
_4:
 end;
X[N-1] := X[N-1]/A[(N-1)+(NC1-1)*N];
if ( N <= 1 ) 
 then goto _8;
N1 := N+1;
for I:=2 to N do
 begin
  K := N1-I;
  SUM := X[K-1];
  if ( NC <= 0 ) 
   then goto _6;
  KL := K+1;
  K1 := Min0(N,K+NC);
  L := 1;
  for J:=KL to K1 do
   begin
    SUM := SUM-X[J-1]*A[(J-1)+(NC1-L-1)*N];
    L := L+1;
_5:
   end;
_6:
  X[K-1] := SUM/A[(K-1)+(NC1-1)*N];
_7:
 end;
_8:
end;

end.
